<?php
/**
 * Plugin cid : Fonctions diverses
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

function action_cid_rubrique_dist() {

	$securiser_action = charger_fonction('securiser_action', 'inc');
	$arg = $securiser_action();

	list($id_rubrique, $statut) = preg_split('/\W/', $arg);
	if (!$statut) $statut = _request('statut_nouv'); // cas POST
	if (!$statut) return; // impossible mais sait-on jamais


	if ($id_rubrique = intval($id_rubrique)) {
		if ($statut=='publie' OR $statut=='prive' OR $statut=='new' OR $statut=='prepa') {
			// cf autorisations dans action/editer_rubrique
			if (autoriser('modifier', 'rubrique', $id_rubrique)) {
				// Ne pas depublier une rubrique qui a des objets publies
				if ($statut=='prive' OR $statut=='new' OR $statut=='prepa') {
					$row = sql_fetsel('date', "spip_rubriques", "id_rubrique=$id_rubrique",'', '');
					if ($row['date'] != "0000-00-00 00:00:00")
						$statut = "";
				} 
				
				if ($statut){
					$action = '';
					$row = sql_fetsel('titre,statut', 'spip_rubriques', 'id_rubrique='.$id_rubrique);
					$statut_ancien = $row['statut'];
					$titre_rubrique = $row['titre'];
					$champs = array('statut'=>$statut, 'date'=>'0000-00-00 00:00:00');
					
					sql_updateq('spip_rubriques', $champs, "id_rubrique=$id_rubrique");

					// invalider les caches marques de cette rubrique
					include_spip('inc/invalideur');
					suivre_invalideur("id='rubrique/$id_rubrique'");
					// et celui de menu_rubriques 
					effacer_meta("date_calcul_rubriques");
					
					// tracer
					if ($statut=='publie' AND $statut_ancien!='publie')
						$action = "publication directe rubrique";
					elseif ($statut!='publie' AND $statut_ancien=='publie')
						$action = "depublication directe rubrique";

					if ($action){
						if (defined('_DIR_PLUGIN_CITRACE')){
							if ($citrace = charger_fonction('citrace', 'inc')) {
								include_spip('inc/texte');
								$titre_rubrique = interdire_scripts(supprimer_numero($titre_rubrique));
								$message = '('.$titre_rubrique.')';							
								$citrace('rubrique', $id_rubrique, $action, $message, $id_rubrique);
							}
						}
					}
				}			
			}
		}
	}

	return true;
}

?>