<?php
/**
 * Plugin cid : Fonctions diverses
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

function cid_verifier_date($date,$heure) {

	$erreurs = array();
	
	if ($date) {
		$jour = substr($date,0,2);
		$mois = substr($date,3,2);
		$annee = substr($date,6,4);
	
		if (!checkdate( intval($mois), intval($jour), intval($annee)))
			$erreurs['message_erreur'] = _T('cid:erreur_date');
	
		if (intval($annee)<1001)
			$erreurs['message_erreur'] = _T('cid:erreur_date');
	
		if ($heure){
			$heure = substr($heure,0,2);
			$minute = substr($heure,3,2);
		
			if (intval($heure)<0 OR intval($heure)>24)
				$erreurs['message_erreur'] = _T('cid:erreur_heure');
			if (intval($minute)<0 OR intval($minute)>60)
				$erreurs['message_erreur'] = _T('cid:erreur_minute');
		
		} else {
			$heure = '00';
			$minute = '00';
		}
	}

	return $erreurs;
}


function cid_maj_datefin($id_article,$datefin,$heurefin,$supprimer) {
	
	$id_article = intval($id_article);
	
	if ($id_article>0) {
		
		if ($supprimer) {
				$result = sql_select("datefin", "spip_cid_datefin", "id_objet=".$id_article." AND objet='article'","","");	
				if ($row = sql_fetch($result)){
					$date_old = $row['datefin'];
					sql_delete("spip_cid_datefin", "id_objet=$id_article AND objet='article'");
					
					if (defined('_DIR_PLUGIN_CITRACE')){
						if ($citrace = charger_fonction('citrace', 'inc')) {
							$row = sql_fetsel('*', 'spip_articles', 'id_article='.$id_article);
							$id_rubrique = $row['id_rubrique'];
							include_spip('inc/texte');
							$article_msg = " - date_depublication_new: supprimee - date_depublication_old:".$date_old
								.' ('.interdire_scripts(supprimer_numero($row['titre'])).')'." - id_rubrique:".$id_rubrique;
							$citrace('article', $id_article, 'modifier', $article_msg, $id_rubrique);					
						}
					}
				}
		} else {
		
			if ($datefin) {
				$date_old = '';

				$jour = substr($datefin,0,2);
				$mois = substr($datefin,3,2);
				$annee = substr($datefin,6,4);
	
	 			if ($heurefin){
		 			$heure = substr($heurefin,0,2);
					$minute = substr($heurefin,3,2);
	 			} else {
		 			$heure = '00';
					$minute = '00';
				}
	
				$date = sprintf("%04s",$annee) . '-' 
					. sprintf("%02s",$mois) . '-'
					. sprintf("%02s",$jour) . ' ' 
					. sprintf("%02s",$heure) . ':'
					. sprintf("%02s",$minute) . ':' 
					. sprintf("%02s",0);

				$result = sql_select("datefin", "spip_cid_datefin", "id_objet=".$id_article." AND objet='article'","","");	
				if ($row = sql_fetch($result)) {
					$date_old = $row['datefin'];
					sql_updateq("spip_cid_datefin", array("datefin" => $date), "id_objet=$id_article AND objet='article'");
				} else {
					sql_insertq('spip_cid_datefin', array('datefin' => $date, 'id_objet' => $id_article, 'objet' => 'article'));
				}
					
				if (defined('_DIR_PLUGIN_CITRACE')){
					if ($citrace = charger_fonction('citrace', 'inc')) {
						$row = sql_fetsel('*', 'spip_articles', 'id_article='.$id_article);
						$id_rubrique = $row['id_rubrique'];
						include_spip('inc/texte');
						$article_msg = " - date_depublication_new:".$date." - date_depublication_old:".$date_old
							.' ('.interdire_scripts(supprimer_numero($row['titre'])).')'." - id_rubrique:".$id_rubrique;
						$citrace('article', $id_article, 'modifier', $article_msg, $id_rubrique);					
					}
				}
				
			}
		}		
	}

	return true;
}


function cid_droit_suppr_facile_rubrique($id_rubrique){
        $return = false;
  
        include_spip('inc/autoriser');

        // si constante, ce droit est reserve aux admin avec option webmestre
	if (defined("_CID_SUPPR_FACILE_RUBRIQUE_RESERVE_WEBMESTRE") 
                AND strtoupper(_CID_SUPPR_FACILE_RUBRIQUE_RESERVE_WEBMESTRE)=="OUI"){
            
            if (autoriser('webmestre') 
                AND !sql_countsel("spip_rubriques", "id_parent=".intval($id_rubrique))){
                $return = true;
            }
            
        // Si on a le droit de modifier cette rubrique et qu'elle ne contient pas de sous rubrique
        } elseif (autoriser('modifier', 'rubrique', intval($id_rubrique)) 
                AND !sql_countsel("spip_rubriques", "id_parent=".intval($id_rubrique))){
                $return = true;
        }
        
        return $return;
}

?>