<?php
/**
 * Plugin ciimport : Importation d'auteurs et de mots-cles
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */


/**
 * Lecture des parametres de configuration du plugin
 * et alimentation de variables globales
 */
function ciimport_lire_meta() {
        static $done = false;
        static $config = array();

        if (!$done){

		$GLOBALS['ciconfig']['ciimportannuaire'] = 'non';
		$GLOBALS['ciconfig']['ciimportauteur'] = array("prenom"=>"0", "nom"=>"1", "messagerie"=>"2");
		$GLOBALS['ciconfig']['ciimportmailcompatible'] = array();

		$f = _DIR_ETC . '_config_ciimport.php';
	
		// parametrage par fichier
		if (@file_exists($f))
			include_once($f);
                
                // memoriser
                if (isset($GLOBALS['ciconfig'])){
                    $config = $GLOBALS['ciconfig'];
                }
                $done = true;		
	}
		
        return $config;
}

function ciimport_texte_export($texte){
    if (empty($texte)){
        return '';        
    } else {
          return textebrut(str_replace(array(',','"','&#171;','&#187;','&#8217;','&#8211;','&#339;','&#176;','&nbsp;'),array("","'","'","'","'","-","oe","°"," "),$texte));
    }
}

function ciimport_titre_rubrique($id_rubrique){
        static $tableau_rubriques = array();
	$return = '';
        $id_rubrique = intval($id_rubrique);
    
        if (!$tableau_rubriques) {
            $result = sql_select("id_rubrique,titre", "spip_rubriques","","","id_rubrique");
            while($row = sql_fetch($result)){
                $tableau_rubriques[$row['id_rubrique']] = ciimport_texte_export($row['titre']);
            }
        }
    
        if ($id_rubrique>0 AND isset($tableau_rubriques[$id_rubrique])) {
            $return = $tableau_rubriques[$id_rubrique];
        }
        
        return $return;
}

function ciimport_nom_auteur($id_auteur){
        static $tableau_auteurs = array();
	$return = '';
        $id_auteur = intval($id_auteur);
    
        if (!$tableau_auteurs) {
            $result = sql_select("id_auteur,nom", "spip_auteurs","","","id_auteur");
            while($row = sql_fetch($result)){
                $tableau_auteurs[$row['id_auteur']] = ciimport_texte_export($row['nom']);
            }
        }
    
        if ($id_auteur>0 AND isset($tableau_auteurs[$id_auteur])) {
            $return = $tableau_auteurs[$id_auteur];
        }
        
	return $return;
}

function ciimport_auteurs_article($id_article){
        static $tableau_auteurs_article = array();
	$return = '';
        $id_article = intval($id_article);
    
        if (!$tableau_auteurs_article) {
            $result = sql_select("id_objet AS id_article,id_auteur", "spip_auteurs_liens", "objet='article'", "", "id_objet");
            
            while($row = sql_fetch($result)){
                $tableau_auteurs_article[$row['id_article']][] = $row['id_auteur'];
            }
        }
    
        if ($id_article>0 AND isset($tableau_auteurs_article[$id_article])) {
            foreach ($tableau_auteurs_article[$id_article] as $id_auteur) {
                if ($return){
                    $return .= ' | ';
                }
                $return .= ciimport_nom_auteur($id_auteur).' (n°'.$id_auteur.')';
            }
        }
        
	return $return;
}

?>