<?php
/**
 * Plugin Publication multi-sites avec filtrage par rubrique
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;


// function cims_pre_boucle(&$boucle){	
function cims_pre_boucle($boucle){	
	$filtrer = false;

	if (test_espace_prive()) {
		// filtrer par rubrique l'envoi des nouveautes 
		if (strpos($boucle->descr["sourcefile"],'squelettes-dist/nouveautes.html')!==false)
			$filtrer = true;
			
		// filtrer par rubrique le suivi editorial
		if (strpos($boucle->descr["sourcefile"],'notifications/article_')!==false)
			$filtrer = true;
		if (strpos($boucle->descr["sourcefile"],'notifications/forum_')!==false)
			$filtrer = true;
		 
	} else {
		// filtrer par rubrique le site public
		$filtrer = true;
	}
		
	if ($filtrer) {

		// le filtrage par rubrique est-il actif ?
		// (ce qui necessite par ailleurs que le multi sites soit actif)
		if (cims_filtrage_actif()) {
	
			$securise = false;
			switch ($boucle->type_requete){
				case 'hierarchie':
				case 'rubriques':
				case 'articles':
				case 'breves':
				case 'sites':
				case 'syndication':
					$t = $boucle->id_table . '.id_rubrique';
					$boucle->where[] = cims_rubriques_du_site_where($t);
					$securise = true;
					break;
				// si les forums sont dans une boucle d'article
				// cette verification message par message est inutile
				// et pese sur la duree des requetes SQL  
/*
				case 'forums':
					$t = $boucle->id_table . '.id_article';
					$where = cims_articles_du_site_where($t);

					if ($GLOBALS['meta']['activer_breves']=='oui') {
						$t = $boucle->id_table . '.id_breve';
						$boucle->where[] = "array('OR',$where,".cims_breves_du_site_where($t).")";
					} else {
						$boucle->where[] = $where;
					}
					$securise = true;
					break;
*/
				case 'evenements':
					$t = $boucle->id_table . '.id_article';
					$boucle->where[] = cims_articles_du_site_where($t);
					$securise = true;
					break;
				case 'signatures':
                                        $primary = $boucle->id_table.'.'.$boucle->primary;
                                        // ajouter une jointure sur petitions si besoin
                                        $t = array_search("spip_petitions", $boucle->from);
                                        if (!$t) $t = trouver_jointure_champ("id_petition", $boucle);
                                        $t = $t . '.id_article';
                                        $boucle->select = array_merge($boucle->select, array($t));
                                        $boucle->where[] = cims_articles_du_site_where($t);				
                                        break;
				case 'syndic_articles':
//					$t = $boucle->id_table . '.' . $boucle->primary;
					$t = $boucle->id_table . '.id_syndic';
					$boucle->where[] = cims_syndic_articles_du_site_where($t);
					$securise = true;
					break;
				case 'documents':
					$t = $boucle->id_table . '.' . $boucle->primary;
					$boucle->where[] = cims_documents_du_site_where($t);
					$securise = true;
					break;
			}
			if ($securise){
				$boucle->hash .= "if (!defined('_DIR_PLUGIN_CIMS')){
				\$link_empty = generer_url_ecrire('admin_vider'); \$link_plugin = generer_url_ecrire('admin_plugin');
				\$message_fr = 'Le multisite a ete desactivé. <a href=\"'.\$link_plugin.'\">Corriger le problème</a> ou <a href=\"'.\$link_empty.'\">vider le cache</a> pour supprimer les restrictions.';
				\$message_en = 'Multi site is now unusable. <a href=\"'.\$link_plugin.'\">Correct this trouble</a> or <a href=\"'.generer_url_ecrire('admin_vider').'\">empty the cache</a> to finish restriction removal.';
				die(\$message_fr.'<br />'.\$message_en);
				}";
			}
		}
	}

	return $boucle;
}


/**
 * Renvoyer le code de la condition where pour la liste des rubriques accessibles
 *
 * @param string $primary
 * @return string
 */
function cims_rubriques_du_site_where($primary,$not='', $_publique=''){
	return "sql_in('$primary', cims_tableau_rubriques_du_site(), '$not')";
}


/**
 * Renvoyer la condition where pour la liste des articles accessibles
 *
 * @param string $primary
 * @return string
 */
function cims_articles_du_site_where($primary, $_publique=''){
	# hack : on utilise zzz pour eviter que l'optimiseur ne confonde avec un morceau de la requete principale
	return "array('IN','$primary','('.sql_get_select('zzza.id_article','spip_articles as zzza',".cims_rubriques_du_site_where('zzza.id_rubrique','',$_publique).",'','','','',\$connect).')')";
}


/**
 * Renvoyer la condition where pour la liste des breves accessibles
 *
 * @param string $primary
 * @return string
 */
function cims_breves_du_site_where($primary, $_publique=''){
	# hack : on utilise zzz pour eviter que l'optimiseur ne confonde avec un morceau de la requete principale
	return "array('IN','$primary','('.sql_get_select('zzzb.id_breve','spip_breves as zzzb',".cims_rubriques_du_site_where('zzzb.id_rubrique','',$_publique).",'','','','',\$connect).')')";
}


/**
 * Renvoyer le code de la condition where pour la liste des syndic articles accessibles
 *
 * @param string $primary
 * @return string
 */
function cims_syndic_articles_du_site_where($primary, $_publique=''){
	# hack : on utilise zzz pour eviter que l'optimiseur ne confonde avec un morceau de la requete principale
	return "array('IN','$primary','('.sql_get_select('zzzs.id_syndic','spip_syndic as zzzs',".cims_rubriques_du_site_where('zzzs.id_rubrique','',$_publique).",'','','','',\$connect).')')";
}


/**
 * Renvoyer le code de la condition where pour la liste des forums accessibles
 * on ne rend visible que les forums qui sont lies a un article, une breve ou une rubrique visible
 *
 * @param string $primary
 * @return string
 */
function cims_forums_du_site_where($primary, $_publique=''){
	# hack : on utilise zzz pour eviter que l'optimiseur ne confonde avec un morceau de la requete principale
	$where = cims_articles_du_site_where('zzzf.id_article','',$_publique);
	if (defined('_DIR_PLUGIN_BREVES') OR ($GLOBALS['spip_version_branche']<3 AND $GLOBALS['meta']['activer_breves']=='oui')){
		$where = "array('OR',$where,".cims_breves_du_site_where('zzzf.id_breve',$_publique).")";
	}
	return "array('IN','$primary','('.sql_get_select('zzzf.id_forum','spip_forum as zzzf',array($where),'','','','',\$connect).')')";
}


/**
 * Renvoyer le code de la condition where pour la liste des documents accessibles
 * on ne rend visible que les docs qui sont lies a un article, une breve ou une rubrique visible
 *
 * @param string $primary
 * @return string
 */
function cims_documents_du_site_where($primary, $_publique=''){
	# hack : on utilise zzz pour eviter que l'optimiseur ne confonde avec un morceau de la requete principale
	$where = "array('AND','zzzd.objet=\'article\'',".cims_articles_du_site_where('zzzd.id_objet',$_publique).")";

        $ci_doc_rubriques = false;
        if (isset($GLOBALS['meta']["documents_objets"]) AND in_array('spip_rubriques',explode(',',$GLOBALS['meta']["documents_objets"]))){
            $ci_doc_rubriques = true;
        }
        
	if ($ci_doc_rubriques) {
		$where = "array('OR',$where,array('AND','zzzd.objet=\'rubrique\'',".cims_rubriques_du_site_where('zzzd.id_objet','',$_publique)."))";
	}
	
	if (defined('_DIR_PLUGIN_BREVES') OR ($GLOBALS['spip_version_branche']<3 AND $GLOBALS['meta']['activer_breves']=='oui')){
		$where = "array('OR',$where,array('AND','zzzd.objet=\'breve\'',".cims_breves_du_site_where('zzzd.id_objet',$_publique)."))";
	}

	if ($GLOBALS['meta']['formats_documents_forum']) {
		$where = "array('OR',$where,array('AND','zzzd.objet=\'forum\'',".cims_forums_du_site_where('zzzd.id_objet',$_publique)."))";
	}

	$where = "array('IN','$primary','('.sql_get_select('zzzd.id_document','spip_documents_liens as zzzd',array($where),'','','','',\$connect).')')";

	return $where;
}

function cims_quete_logo_objet($flux){
    // cas du logo du site spip
    if (isset($flux['args']['objet']) AND $flux['args']['objet']=='site' 
      AND isset($flux['args']['id_objet']) AND intval($flux['args']['id_objet'])==0){
      
        if ($GLOBALS['spip_version_branche']>=4){
      
            if (defined('_DIR_PLUGIN_CIMS') AND defined('_CIMS_ACTIF')){
              			
          	$chercher_logo = charger_fonction('chercher_logo', 'inc');
          	$objet = 'cimssite';
          	$id_objet = cims_num_site();
                $mode = 'on';
//              $cle_objet = id_table_objet($objet);
                $cle_objet = 'id_cimssite';
          
          	// On cherche par la méthode classique
          	$infos_logo = $chercher_logo($id_objet, $cle_objet, $mode);
          	// Si la méthode classique a trouvé quelque chose, on utilise le nouveau format
          	if (!empty($infos_logo)) {
          		$infos_logo = array(
          			'chemin' => $infos_logo[0],
          			'timestamp' => $infos_logo[4],
          		);
          		
          		$flux['args']['id_objet'] = $id_objet;
          		$flux['data'] = $infos_logo;
          	} else {
          		$flux['data'] = array();
                }
  			
            }
        }
    }
    
	return $flux;
}

?>