<?php
/**
 * Plugin Publication multi-sites avec filtrage par rubrique
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/cims_commun');

function formulaires_cims_rubriques_charger_dist($multisite, $retour=''){
	$multisite = cims_verif_site($multisite);
	
	if (!$multisite)
		return false;

	$valeurs = array();
        
	// rubriques de ce site memorisees dans la base
	$oldrubriques = array();
	$result = sql_select("id_rubrique", "spip_cims_multisites", "multisite='$multisite'", "", "id_rubrique");
	while ($row = sql_fetch($result))
		$oldrubriques[] = $row['id_rubrique'];
		
	$valeurs['argmultisite'] = $multisite;
	$valeurs['_hidden'] = "<input type='hidden' name='multisite' value='".$multisite."' /><input type='hidden' name='cimodif_img_avant' value='".implode(",", $oldrubriques)."' />";

	return $valeurs;
}

function formulaires_cims_rubriques_verifier_dist($multisite, $retour=''){
        $erreurs = array();
	return $erreurs;
}

function formulaires_cims_rubriques_traiter_dist($multisite, $retour=''){
	$multisite = cims_verif_site($multisite);
        $insertrubrique = array();
        $deleterubrique = array();
        $res = array();
	
	if ($multisite AND autoriser('configurer', 'configuration')) {
	
		$rubriques = _request('rubriques');
		$ci_rubrique_img_avant = _request('cimodif_img_avant');
		
		// rubriques de ce site memorisees dans la base
		$oldrubriques = array();
		$result = sql_select("id_rubrique", "spip_cims_multisites", "multisite='$multisite'", "", "id_rubrique");
		while ($row = sql_fetch($result))
			$oldrubriques[] = $row['id_rubrique'];

			
		// Pr�vention des acc�s concurents
		$ci_rubrique_img_base = "";
		if ($oldrubriques) $ci_rubrique_img_base = implode(",", $oldrubriques);
		$cirubrique_concurrent=false;
		if ($ci_rubrique_img_avant) {
			if ($ci_rubrique_img_base) {
				if (!($ci_rubrique_img_avant==$ci_rubrique_img_base)) $cirubrique_concurrent=true;
			} else {
				$cirubrique_concurrent=true;
			}		
		} elseif ($ci_rubrique_img_base) $cirubrique_concurrent=true;
	
		if (!$cirubrique_concurrent) {
			
			if (defined('_DIR_PLUGIN_CIAR')){
				include_spip('ciar_fonctions');
				$oldrubriques = array_diff($oldrubriques,ciar_accessrubec());
			}

                        if (defined('_CI_SEN') AND _CI_SEN=='oui'){
                            if (defined('_DIR_PLUGIN_GESTIDE')) {
				include_spip('gestide_fonctions');
				$oldrubriques = array_diff($oldrubriques,gestide_rubriques_imposees());
                            }
			}
                        
			if (isset($rubriques) AND is_array($rubriques)) {
				if (isset($oldrubriques) AND is_array($oldrubriques)) {
					foreach ($rubriques as $rubrique) {
						if (in_array($rubrique,$oldrubriques)){
							// si la nouvelle rubrique est la meme que celle en base, ne rien faire
						} else {
							$insertrubrique[] = $rubrique;
						}		
					}
				} else {
					foreach ($rubriques as $rubrique) {
						$insertrubrique[] = $rubrique;
					}
				}
			}

			if (isset($oldrubriques) AND is_array($oldrubriques)) {
				reset($oldrubriques);
				if (isset($rubriques) AND is_array($rubriques)) {
					reset($rubriques);
					foreach ($oldrubriques as $oldrubrique) {
						if (in_array($oldrubrique,$rubriques)){
							// si l'ancien mot est toujours l�, ne rien faire
						} else {
							$deleterubrique[] = $oldrubrique;
						}		
					}
				} else {
					foreach ($oldrubriques as $oldrubrique) {
						$deleterubrique[] = $oldrubrique;
					}
				}
			}			
			
			if ($insertrubrique) {
				foreach ($insertrubrique as $rub) {
					sql_insertq('spip_cims_multisites', array('id_rubrique' => $rub, 'multisite' => $multisite));
				}
			}

			if ($deleterubrique){
				sql_delete("spip_cims_multisites", "multisite='".$multisite."' AND ".sql_in('id_rubrique',$deleterubrique));	
			}

			// tracer
			if (defined('_DIR_PLUGIN_CITRACE')){
				if ($citrace = charger_fonction('citrace', 'inc')){

					if ($insertrubrique) {
						asort($insertrubrique);
						reset($insertrubrique);
						$citrace('site', $multisite, 'ajouter rubrique au site', 'rubriques:'.implode(',',$insertrubrique));	
					}
					if ($deleterubrique){
						asort($deleterubrique);
						reset($deleterubrique);
						$citrace('site', $multisite, 'retirer rubrique du site', 'rubriques:'.implode(',',$deleterubrique));
					}
				}
			}

		}			
	}


	$res['message_ok'] = "";
//	$res['redirect'] = $retour;
	
	return $res;	
}

function cims_verif_site($multisite){
	$return = '';
	if ($multisite){
                $tableau_config = cims_lire_config();
		if (isset($tableau_config['cilistedessites'])) {
		    foreach ($tableau_config['cilistedessites'] as $key=>$valeur) {
		    	if ($valeur == $multisite) {
			    	$return = $valeur;
		    	}
		    }
		}
	}
	return $return;
}

// Construit le plan du site (volumetrie rubrique)
// Renvoi le plan � partir d'un tableau des rubriques concern�es
function cims_plan($multisite){
	global $citexteplan;
	global $ciarboplan;
	global $cirub_site;
	global $ci_editer;
	global $cimstoutcocher;
	global $cimstoutcochertop;
	
	$multisite = cims_verif_site($multisite);

	if ($multisite){
		if (autoriser('configurer', 'configuration'))
			$ci_editer = true;
		else
			$ci_editer = false;
	
		
		// affectation actuelle du site aux rubriques
		$cirub = array();
		$result = sql_select("id_rubrique", "spip_cims_multisites", "multisite='$multisite'", "", "id_rubrique");
		while ($row = sql_fetch($result))
			$cirub['p'.$row['id_rubrique']] = $row['id_rubrique'];
	
		$cirub_site = $cirub;
	
		// titre du site
                $tableau_config = cims_lire_config();
		$description = '';
		if (isset($tableau_config['cilistedessites'])) {
		    foreach ($tableau_config['cilistedessites'] as $key=>$valeur) {
		    	if ($valeur == $multisite) {
			    	$description = cims_htmlentities($tableau_config['cinomdessites'][$key]);
		    	}
		    }
		}
		
		if (autoriser('configurer', 'configuration'))
			$edition = true;
		else
			$edition = false;

		$cimstoutcocher = ' <a onclick="cimscocher(this)">'._T('cims:tout_cocher').'</a> / <a onclick="cimsdecocher(this)">'._T('cims:tout_decocher').'</a>';		
		$cimstoutcochertop = ' <a onclick="cimstopcocher(this)">'._T('cims:tout_cocher').'</a> / <a onclick="cimstopdecocher(this)">'._T('cims:tout_decocher').'</a>';		
			
		$ciarboplan = cims_arbo_rubriques();
		$citexteplan = '<div style="margin:0;padding:0;">';
		cims_enfantplan(0);
		$citexteplan .= '</div>';
	}	
	return $citexteplan;  
}

// Renvoi un  tableau associant chaque rubrique parente � un tableau de ses rubriques filles
function cims_arbo_rubriques() {
	$ciarbo = array();
	$cienfants = array();
	$ciparent = 0;
	$row = array();
	
	$where = '';
	
	if (defined('_DIR_PLUGIN_CIAR')){
		include_spip('ciar_fonctions');
		$where = sql_in('id_rubrique',ciar_accessrubec(),'NOT');
	}

	$result = sql_select("id_parent,id_rubrique,titre", "spip_rubriques", $where, "", "id_parent,0+titre,titre");
	while ($row = sql_fetch($result)) {		
		if ($ciparent) {
			if ($ciparent!=$row['id_parent']+1) {
					$ciarbo["p".strval($ciparent-1)] = $cienfants;

				$ciparent = $row['id_parent']+1;
				$cienfants = array();
			}
		} else {
			$ciparent = $row['id_parent']+1;
		}
		
		$cienfants[] = array($row['id_rubrique'],$row['titre']);
	}
	// Traiter le dernier lot 
	if ($ciparent) {
		$ciarbo["p".strval($ciparent-1)] = $cienfants;
		$ciparent = $row['id_parent']+1;
		$cienfants = array();
	}

	return $ciarbo;
}

function cims_enfantplan($leparent){
	global $id_parent;
	global $id_rubrique;
	static $i = 0;
	global $ciarboplan;
	global $citexteplan;
	global $cirub_site;
	global $ci_editer;
	global $cimstoutcocher;
	global $cimstoutcochertop;
	
	$i++;
 	$citableau = $ciarboplan["p".strval($leparent)];	
	 	
 	if ($citableau) {
		
 		$citexteplan .= '<ul style="list-style:none;margin:5px 0 0 20px;padding:0;">';
	 	foreach($citableau as $row) {
			$my_rubrique=$row[0];
			$titre=$row[1];
		
			$cidecal = str_repeat("&nbsp;",5*($i-1));
			$titre = interdire_scripts(typo(extraire_multi($titre)));

			$propager = '';
			$checked = '';
			$gras = '';
			$disabled = '';
			if (isset($cirub_site['p'.$my_rubrique])){
				$checked = 'checked="checked"';
				$gras = ' on';
			}
			if (!$ci_editer)
				$disabled =' disabled="disabled" ';
			
			if ($ci_editer) {
				if ($ciarboplan["p".strval($my_rubrique)]){
					$propager = $cimstoutcocher;
					$propagertop = $cimstoutcochertop;
				}
			}

			if ($i<2)
				$citexteplan .= '<li><div style="margin-top:10px;background-color:#C0CAD4;"><input type="checkbox" id="rub'.$my_rubrique.'" name="rubriques[]" value="'.$my_rubrique.'" '.$checked.$disabled.' /><label for="rub'.$my_rubrique.'" class="texte'.$gras.'" > '.$titre.'</label>'.$propagertop.'</div>';
			else		
				$citexteplan .= '<li><input type="checkbox" id="rub'.$my_rubrique.'" name="rubriques[]" value="'.$my_rubrique.'" '.$checked.$disabled.' /><label for="rub'.$my_rubrique.'" class="texte'.$gras.'"> '.$titre.'</label>'.$propager;
			
			cims_enfantplan($my_rubrique);
 			$citexteplan .= '</li>';
		}

	
 		$citexteplan .= '</ul>';
 	}	
	$i=$i-1;
	
	return true;
}


?>