<?php
/**
 * Plugin Publication multi-sites avec filtrage par rubrique
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;
 
include_spip('inc/cims_commun');

function formulaires_editer_cims_rubrique_charger($type,$id){
	$valeurs = array();
	$table = table_objet_sql($type);
	$id_table_objet = id_table_objet($type);
	$champ = "multisite";
	$valeurs[$id_table_objet] = intval($id);

	$valeurs['_liste_site_rubrique'] = cims_liste_site($table,$id_table_objet,$id,$champ);
	$valeurs['_choix_site_rubrique'] = cims_choix_site($table,$id_table_objet,$id,$champ);

	if (!$valeurs['_choix_site_rubrique'])
		$valeurs['masquer'] = "oui";
	else	
		$valeurs['masquer'] = "non";
	
	$valeurs['_hidden'] = "<input type='hidden' name='$id_table_objet' value='$id' />";

	return $valeurs;
}


function formulaires_editer_cims_rubrique_traiter($type,$id){
	$valeurs = array();
	$table_objet_sql = table_objet_sql($type);
	$id_table_objet = id_table_objet($type);

	if (autoriser('configurer')){
		cims_ajout_site("spip_cims_multisites",$id_table_objet,$id,'multisite',_request('multisite'));
		if (defined('_DIR_PLUGIN_CITRACE')){
			if ($citrace = charger_fonction('citrace', 'inc'))
				$citrace('site', _request('multisite'), 'ajouter rubrique au site', 'rubrique:'.$id);
		}
	}

	return array('message_ok'=>'','editable'=>true);
}


function cims_liste_site($table,$id_table_objet,$id,$champ) {
	$texte = "";
	$valeurs = "";
	$tablejointure = "spip_cims_multisites";
	
	if ($id) {	
		$valeurs = cims_lire_valeurs($tablejointure,$id_table_objet,$id,$champ);
		$tableau_config = cims_lire_config();
    	
		if ($valeurs AND isset($tableau_config['cilistedessites'])) {
			$texte = '<div class="liste-objets"><table cellspacing="0" cellpadding="2" border="0" width="100%">';
			$texte .= '<tbody>';
		    foreach ($tableau_config['cilistedessites'] as $key=>$id_site) {
		    	if (in_array($id_site,$valeurs)) {
		    		// subtilites de SPIP 
                                include_spip('inc/filtres');
    				$fichier_exec = 'rubrique';

		    		// enlever le "s" final le cas echeant
		    		$objet = 'rubrique';
		    		
					$own = array(true,$id, $objet, '', 'rubriques', $id_table_objet, $fichier_exec);
			    	$nom = $id_site;
			    	$description = cims_htmlentities($tableau_config['cinomdessites'][$key]);
		    		$texte .= '<tr class="tr_liste"><td class="arial2"><a href="'.generer_url_ecrire("cims_rubriques","multisite=$nom&ciretour=$id").'">'.$description.'</a></td>';
                                if (autoriser('configurer')){
                                        $redirect = str_replace("&amp;","&",self());
                                        $texte .= '<td class="action"><a href="'.generer_action_auteur("cims_supprimer", $objet.'-'.$id.'-multisite-'.$nom, $redirect).'">'
                                ._T('ciparam:retirer')."&nbsp;"
                                ."<img src='".chemin_image('supprimer-12.png')."' width='12' height='12' alt='X' />"
                                        .'</a></td></tr>';
                        }
		    	}
		    }
		    $texte .="</tbody></table></div>";
		}
	}

	return $texte;  
}	


function cims_choix_site($table,$id_table_objet,$id,$champ) {
	$texte = "";
	$valeur = "";
	$tablejointure = "spip_cims_multisites";
	
	if ($id) {	
		$valeurs = cims_lire_valeurs($tablejointure,$id_table_objet,$id,$champ);
		$tableau_config = cims_lire_config();

		if (isset($tableau_config['cilistedessites'])) {
			$texte = "\n<select name=$champ class=fondl style=width:420px;font-size:11px;>\n";
    		$texte .= '<option value=__aucun_site selected></option>\n';
			
		    foreach ($tableau_config['cilistedessites'] as $key=>$id_site) {
		    	if (!$valeurs OR !in_array($id_site,$valeurs)) { 
			    	$nom = $id_site;
			    	$description = cims_htmlentities($tableau_config['cinomdessites'][$key]);
		    		$texte .= "<option value=$nom>".$description."</option>\n";
		    	}
		    }
		    $texte .="</select>\n";
		}
	}
	
	return $texte;  
}	


function cims_ajout_site($table,$id_table,$id_valeur,$champ,$valeur) {
	// cas de deselection d'une forme
	if ($champ=='multisite' AND $valeur=='__aucun_site') {
		// ne rien faire
	} else {	
		cims_ajout_valeur($table,$id_table,$id_valeur,$champ,$valeur);
	}
}


function cims_lire_valeurs($table,$id_table,$id_valeur,$champ) {
	$valeurs = array();
	
	$result = sql_select("$champ", "$table", "$id_table=$id_valeur","","");	
	while ($row = sql_fetch($result)) {
		$valeurs[] = $row[$champ];
	}

	return $valeurs;
}


function cims_ajout_valeur($table,$id_table,$id_valeur,$champ,$valeur) {
	$id = sql_insertq("$table", array(
	$id_table => $id_valeur,
	$champ =>  $valeur));

	return true;
}


function cims_editer_sites_un($multisite, $own) {
	$retire = '';

	list ($flag_editable, $id_objet, $objet, $ret, $table, $table_id, $url_base) = $own;
	
	if (autoriser('configurer'))
		$r =  _T('cims:retirer')
			  . "&nbsp;"
			  . http_img_pack('croix-rouge.gif', "X", " class='puce' style='vertical-align: bottom;'");
	else
		$r = "";
	
	$retire = ajax_action_auteur('editer_multisites', "$id_objet,$multisite,$table,$table_id,$objet", $url_base, "$table_id=$id_objet", array($r,''),"&id_objet=$id_objet&objet=$objet");


	return $retire;
}

?>