<?php
/**
 * Plugin Configurateur de squelettes
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */
include_spip('inc/ciparam_inc_commun');

function formulaires_ciparam_choix_rubrique_charger($type,$id_rubrique){

	$valeurs = array();
        $id_rubrique = intval($id_rubrique);
	$table = table_objet_sql($type);
	$id_table_objet = id_table_objet($type);
	$valeurs[$id_table_objet] = $id_rubrique;

	if ($id_rubrique<1)
		return false;
        
	if (!autoriser('modifier', 'rubrique', $id_rubrique))
		return false;

	$valeurs['_hidden'] = "<input type='hidden' name='$id_table_objet' value='$id_rubrique' />";
        
	// forme
	$valeurs['_choix_forme_rubrique'] = ciparam_choix_forme($table,$id_table_objet,$id_rubrique,"ciforme");
	if ($valeurs['_choix_forme_rubrique'])
		$valeurs['masquer_choix_forme_rubrique'] = "non";
	else	
		$valeurs['masquer_choix_forme_rubrique'] = "oui";
	
        // raccourcis
	$valeurs['_liste_raccourci_rubrique'] = ciparam_liste_raccourci($table,$id_table_objet,$id_rubrique,"raccourci");
	$valeurs['_choix_raccourci_rubrique'] = ciparam_choix_raccourci($table,$id_table_objet,$id_rubrique,"raccourci");
	if ($valeurs['_choix_raccourci_rubrique'])
		$valeurs['masquer_choix_raccourci_rubrique'] = "non";
	else	
		$valeurs['masquer_choix_raccourci_rubrique'] = "oui";

	// tri
        $valeurs['_choix_tri_rubrique'] = ciparam_choix_tri($table,$id_table_objet,$id_rubrique,"citri");
	if ($valeurs['_choix_tri_rubrique'])
		$valeurs['masquer_choix_tri_rubrique'] = "non";
	else	
		$valeurs['masquer_choix_tri_rubrique'] = "oui";

        // rang / rangspa / nbactu
	$valeurs['supprimer_lien'] = '';
	$valeurs['_cinbactu'] = '5';
	$row = sql_fetsel("*", "spip_rubriques", "id_rubrique=".$id_rubrique,"","");	
	if ($row){
            $valeurs['_cirangse'] = $row['cirangse'];
            $valeurs['_cirangspae'] = $row['cirangspae'];
            if (isset($row['cinbactu']) AND intval($row['cinbactu'])>0) 
                $valeurs['_cinbactu'] = $row['cinbactu'];
            
            if (sql_countsel('spip_ci_raccourcis_rubriques', "id_rubrique=".$id_rubrique." AND raccourci LIKE '_portail_droite_titre_bloc%'")>=1)            
                $valeurs['masquer_cirang'] = "non";
            else	
                $valeurs['masquer_cirang'] = "oui";

            if (sql_countsel('spip_ci_raccourcis_rubriques', "id_rubrique=".$id_rubrique." AND raccourci LIKE '_souspageaccueil_droite_titre_bloc%'")>=1)
                $valeurs['masquer_cirangspa'] = "non";
            else	
                $valeurs['masquer_cirangspa'] = "oui";
            
            if (in_array($row['ciforme'],array('_souspageaccueil','_avecactualite')))
                $valeurs['masquer_cinbactu'] = "non";
            else	
                $valeurs['masquer_cinbactu'] = "oui";
        }

	return $valeurs;
}


function formulaires_ciparam_choix_rubrique_verifier($type,$id_rubrique){
	$erreurs = array();

	$row = sql_fetsel("*", "spip_rubriques", "id_rubrique=".$id_rubrique,"","");	
	if ($row){
            if (in_array($row['ciforme'],array('_souspageaccueil','_avecactualite'))){
                $nbactu = intval(_request('cinbactu'));
                if ($nbactu<1 OR $nbactu>20){
                        $erreurs['cinbactu'] = _T('ciparam:erreur_nbactu');
                }
            }
        }
        
	return $erreurs;	
}


function formulaires_ciparam_choix_rubrique_traiter($type,$id_rubrique){
	$valeurs = array();
	$table_objet_sql = table_objet_sql($type);
	$id_table_objet = id_table_objet($type);
        $invalideurs = false;
       
        // memoriser les anciennes valeurs
        $criteres = array('ciforme','citri','citrinum','citriinverse','cirangse','cirangspae','cinbactu');
        $old_valeurs = array();
	$row = sql_fetsel("*", "spip_rubriques", "id_rubrique=".$id_rubrique,"","");	
	if ($row){
            foreach ($criteres AS $critere)
                $old_valeurs[$critere] = $row[$critere];
            
            // cas particulier du tri
            $row_to_tri = ciparam_row_to_tri($row);
            $old_valeurs['tri'] = $row_to_tri['nom'].'_'.$row_to_tri['ordre'];
        }
        
        // memoriser les anciens raccourcis
        $old_raccourcis = array();
        $result = sql_select("raccourci", "spip_ci_raccourcis_rubriques", "id_rubrique=$id_rubrique");
        while ($row = sql_fetch($result))
            $old_raccourcis[] = $row['raccourci'];

        
        // forme
        $ciforme = _request('ciforme');
        if ($ciforme AND (!isset($old_valeurs['ciforme']) OR $ciforme!=$old_valeurs['ciforme']))
            ciparam_maj_forme($type,"spip_rubriques",$id_table_objet,$id_rubrique,'ciforme',$ciforme);
	
        // raccourcis
		$supprimer = _request('supprimer_lien');
		if ($supprimer){
			foreach($supprimer as $k=>$v) {
				if (preg_match(",^\w+-[\w*]+-[\w*]+-[\w*]+,",$k)){
					$lien = explode("-",$k);
					list($objet_source,$ids,$objet_lie,$idl) = $lien;
					if ($type AND $id_rubrique AND $objet_lie=='raccourci' AND $raccourci=$idl) {
					  // desassocier un des raccourcis
						sql_delete("spip_ci_raccourcis_rubriques", "id_rubrique=$id_rubrique AND raccourci='$raccourci'");
					}
				}
			}
			// Invalider les caches	
                        $invalideurs = true;
		}
	
        $raccourci = _request('raccourci');
        if ($raccourci AND (!$old_raccourcis OR !in_array($raccourci,$old_raccourcis)))
            ciparam_ajout_raccourci($type,"spip_ci_raccourcis_rubriques",$id_table_objet,$id_rubrique,'raccourci',$raccourci);
    
	// tri
        $citri = _request('citri');
        if ($citri AND (!isset($old_valeurs['tri']) OR $citri!=$old_valeurs['tri'])){
            ciparam_maj_tri("spip_rubriques",$id_table_objet,$id_rubrique,'citri',$citri);
            $invalideurs = true;
        }
        
        // rang
        $cirangse = intval(_request('cirangse'));
        if ($cirangse AND (!isset($old_valeurs['cirangse']) OR $cirangse!=$old_valeurs['cirangse'])){
            sql_updateq("spip_rubriques", array("cirangse" => $cirangse), "id_rubrique=".intval($id_rubrique));
            $invalideurs = true;
        }
        
        // rangspa
        $cirangspae = intval(_request('cirangspae'));
        if ($cirangspae AND (!isset($old_valeurs['cirangspae']) OR $cirangspae!=$old_valeurs['cirangspae'])){
            sql_updateq("spip_rubriques", array("cirangspae" => $cirangspae), "id_rubrique=".intval($id_rubrique));
            $invalideurs = true;
        }
        
        // nbactu
        $cinbactu = intval(_request('cinbactu'));
        if ($cinbactu AND (!isset($old_valeurs['cinbactu']) OR $cinbactu!=$old_valeurs['cinbactu'])){
            sql_updateq("spip_rubriques", array("cinbactu" => intval(_request('cinbactu'))), "id_rubrique=".$id_rubrique);
            $invalideurs = true;
        }
        
        // Invalider les caches	si besoin
        if ($invalideurs){
            include_spip('inc/invalideur');
            suivre_invalideur("id='rubrique/$id_rubrique'");
        }    
        
	return array('message_ok'=>'','editable'=>true);
}

?>