<?php
/**
 * Plugin squelettes de base
 * Auteur : Christophe IMBERTI
 * Licence GPL
 */


/**
 * Lecture du parametrage par fichier du plugin
 *
 * @param : aucun
 * @return : false si parametrage par fichier, sinon true
 */
function cisquel_lire_meta() {
        static $done = false;
        static $config = array();

        if (!$done){

		// Afficher dans la colonne centrale le choix de restreindre la recherche avec des options de recherche (filtre par date et choix du tri)
		// valeurs possible : 'oui', 'non' (la valeur par defaut est 'oui')
		// Exemple :
		$GLOBALS['ciconfig']['cisqueloptionsrecherchecolcentrale'] = 'oui';
		
		// Afficher dans la colonne de gauche le choix de restreindre la recherche avec des options de recherche (filtre par date et choix du tri)
		// valeurs possible : 'oui', 'non' (la valeur par defaut est 'oui')
		// Exemple :
		$GLOBALS['ciconfig']['cisqueloptionsrecherchecolgauche'] = 'oui';
		
		// Afficher le choix d'elargir la recherche via un autre moteur de recherche
		// valeurs possible : 'oui', 'non' (la valeur par defaut est 'non')
		$GLOBALS['ciconfig']['cisquelchoixelargirrecherche'] = 'non';
		
		// tableau des choix d'elargir la recherche via un autre moteur de recherche selon le type de debut ou de fin d'adresse d'appel du site SPIP
		// valeurs possible : 'oui', 'non' (la valeur par defaut est 'non')
		// Exemple :
		$GLOBALS['ciconfig']['cisquelchoixelargirrecherche_selon_host'] = array();
		
		// Afficher la recherche sur le site et le contenu de ses documents
		// valeurs possible : 'oui', 'non' (la valeur par defaut est 'non')
		$GLOBALS['ciconfig']['cisquelchoixrecherchesiteetdocuments'] = 'non';
		
		// Afficher la recherche sur tous les sites
		// valeurs possible : 'oui', 'non' (la valeur par defaut est 'non')
		$GLOBALS['ciconfig']['cisquelchoixrecherchetouslessites'] = 'non';
		
		// moteur de recherche par defaut
		// valeurs possible : 'mnogosearch', 'google' (la valeur par defaut est 'google')
		$GLOBALS['ciconfig']['cisquelmoteur'] = 'google';
		
		// tableau des moteurs de recherche selon le type de terminaison de l'adresse d'appel du site SPIP
		// valeurs possible des moteurs : 'mnogosearch', 'google'
		// exemple : array('.i2' => 'mnogosearch', '.gouv.fr' => 'google')
		$GLOBALS['ciconfig']['cisquelmoteurs_selon_host'] = array();
		
		// URL du moteur de recherche par defaut (sans http://)
		// la valeur par defaut est 'www.google.fr/search'
		$GLOBALS['ciconfig']['cisquelmoteururl'] = 'www.google.fr/search';
		
		// tableau des URLS du moteur de recherche selon le type de terminaison de l'adresse d'appel du site SPIP
		// exemple : array('.i2' => 'recherche.....i2/index.mno', '.gouv.fr' => 'www.google.fr/search')
		$GLOBALS['ciconfig']['cisquelmoteursurls_selon_host'] = array();
		
		// domaine de recherche eventuel sur tous les sites (utile pour google)
		// exemple : '.developpement-durable.gouv.fr'
		$GLOBALS['ciconfig']['cisqueldomainetoussites'] = '';
		
		// valeurs de certains parametres de mnogosearch
		$GLOBALS['ciconfig']['cisquelmnogosearch'] = array(
			'avancee' => '',
			's' => 'R',
			'ps' => '15',
			'cat' => '',
			'wf' => '0A8A0000AAF7FACC1',
			'fmt' => 'long',
			'ftm' => 'long',
			'GroupBySite' => 'no',
			'tl' => 'yes',
			'm' => 'all',
			'categorie' => '',
			'type' => '',
			'dp' => '0',
			'dt' => 'back');

		// Affiner la recherche pour les types de documents (hors html) suivants (mettre l'extension en minuscules sans le point)
		// Attention : les libelles doivent etre independants de la langue (fr, es, de)
		$GLOBALS['ciconfig']['cisqueltypesdocuments'] = array('pdf'=>'Adobe PDF (*.pdf)','odt'=>'OpenOffice Text (*.odt)','doc'=>'Word (*.doc)');
			
		// Types de documents (hors html) indexes par mnogosearch (mettre l'extension en minuscules sans le point)
		$GLOBALS['ciconfig']['cisquelmnotypesdocuments'] = array('pdf','odt','doc');
			
		// Option qui necessite le template de mnogosearch du MEDDTL
		// Afficher dans la page les resultats trouves par mnogosearch
		// valeurs possible : 'oui', 'non' (la valeur par defaut est 'non')
		$GLOBALS['ciconfig']['cisquelgetmnosite'] = 'non';
		
		// Option qui necessite le template de mnogosearch du MEDDTL
		// Afficher dans la page les resultats trouves par mnogosearch pour TOUS les sites
		// valeurs possible : 'oui', 'non' (la valeur par defaut est 'non')
		// Exemple :
		$GLOBALS['ciconfig']['cisquelgetmnotoussites'] = 'non';			
		
		// parametrage par le fichier _config_cisquel.php dans /config
		// ou parametrage par le fichier _config_commun_cisquel.php dans le dossier du plugin
		// Si les deux fichiers sont presents,
		// le contenu de celui present dans /config est prioritaire car il est propre au site
		// (le fichier _config_cisquel.php est charge apres le fichier _config_commun_cisquel.php).
		// Cela permet d'avoir les parametres communs a tous les sites dans _config_commun_cisquel.php
		// et les parametres propres a un site dans _config_cisquel.php
		if (@file_exists($f2 = _DIR_RACINE . _DIR_PLUGIN_CISQUEL . '_config_commun_cisquel.php')) {
			include_once($f2);
			$return = false;
		}
		if (@file_exists($f = _DIR_ETC . '_config_cisquel.php')) {
			include_once($f);
			$return = false;
		}
                
                // memoriser
                if (isset($GLOBALS['ciconfig'])){
                    $config = $GLOBALS['ciconfig'];
                }
                $done = true;		
	}
		
    return $config;
}

/**
 * Valeur d'un parametre du plugin
 *
 * @param : parametre du plugin
 *			cle dans un tableau de parametres
 * @return : valeur du parametre
 */
function cisquel_config($param, $param_cle='') {
	$return = false;

	// lire la configuration du plugin
	$tableau_config = cisquel_lire_meta();
	
	if ($param) {
		if (isset($tableau_config[$param])) {
			$return = $tableau_config[$param];
			if (is_array($tableau_config[$param])) {
				if ($param_cle) {
					if (isset($tableau_config[$param][$param_cle]))
						$return = $tableau_config[$param][$param_cle];
				}
			}
		}
	}
	
    return $return;
}


function cisquel_verifier_parametres($p) {
	$p_safe = array();

	$p_safe['recherche'] = '';
	$p_safe['tri'] = false;
	$p_safe['age'] = false;
	$p_safe['datedebut'] = false;
	$p_safe['datefin'] = false;
	$p_safe['typedoc'] = false;
	$p_safe['elargir'] = false;
	$p_safe['np'] = false;
	$p_safe['onglet'] = 'article';

	if (isset($p['recherche']))
		$p_safe['recherche'] = cisquel_filtrer_recherche($p['recherche']);
	
	if (isset($p['tri']) AND in_array($p['tri'],array('date','datedesc')))
		$p_safe['tri'] = $p['tri'];
	
	if (isset($p['age']) AND intval($p['age'])>0)
		$p_safe['age'] = intval($p['age']);
	
	if (isset($p['datedebut']) AND cisquel_verifier_et_convertir_date($p['datedebut'])>0)
		$p_safe['datedebut'] = $p['datedebut'];

	if (isset($p['datefin']) AND cisquel_verifier_et_convertir_date($p['datefin'])>0)
		$p_safe['datefin'] = $p['datefin'];

	if (isset($p['typedoc'])) {
		$typesdoc = cisquel_typesdoc();
		if ($typesdoc AND is_array($typesdoc)) {
			if (in_array($p['typedoc'],$typesdoc))
				$p_safe['typedoc'] = $p['typedoc'];
		}
	}

	if (isset($p['elargir']) AND in_array($p['elargir'],array('doc','toussites')))
		$p_safe['elargir'] = $p['elargir'];

	if (isset($p['np']) AND intval($p['np'])>0)
		$p_safe['np'] = intval($p['np']);
		
        $tableau = array('debut_articles',
                        'debut_rubriques',
                        'debut_doc',
                        'debut_messages');

        foreach ($tableau as $valeur) {
            $p_safe[$valeur] = false;
            if (isset($p[$valeur]) AND intval($p[$valeur])>0)
                $p_safe[$valeur] = intval($p[$valeur]);
        }
		
	if (isset($p['onglet']) AND in_array($p['onglet'],array('article','rubrique','document','forum')))
		$p_safe['onglet'] = $p['onglet'];
	
	return $p_safe;
}

function cisquel_nomfichier($fichier) {
	// enlever le chemin
	$titre = $fichier;
        
        if ($titre){
            $pos3 = strrpos($titre,"/");
            if (!($pos3 === false)){
                $titre=substr($titre,$pos3+1);
            }
        }
	return $titre;
}

function cisquel_titrefichier($fichier) {
	// enlever l'extension et le chemin
	$titre = $fichier;
        if ($titre){
            $pos1 = strrpos($titre,".");
            if (!($pos1 === false)){
                $titre=substr($titre,0,$pos1);
            }

            $pos3 = strrpos($titre,"/");
            if (!($pos3 === false)){
                $titre=substr($titre,$pos3+1);
            }
        }
	return $titre;
}

function cisquel_enlever_cle($fichier) {
	if ($fichier AND substr($fichier, -10, 4)=='_cle')
		$fichier = substr($fichier,0,-10);

	return $fichier;
}

function cisquel_taille_en_octets ($taille) {
	if ($taille)
		$taille = taille_en_octets($taille);
	else
		$taille = '';

	return $taille;
}


function cisquel_getonglet($recherche, $env) {

	// indispensable (necessite un #ENV sans filtre)
	$unenv = unserialize($env);
	
	// securite
	$p = cisquel_verifier_parametres($unenv);	

	return $p['onglet'];
}


function cisquel_typesdoc($a='') {
	$typesdoc = array();
	
	// lire la configuration du plugin
	$t = cisquel_config('cisqueltypesdocuments');
	if ($t AND is_array($t)) {
		foreach ($t as $cle=>$valeur)
			$typesdoc[] = $cle;
	}

	return $typesdoc;
}

function cisquel_typesdoclib($extension) {
	static $typesdoclib = array();
	$return	= $extension;
	
	if (!$typesdoclib) {
		// lire la configuration du plugin
		$t = cisquel_config('cisqueltypesdocuments');
		if ($t AND is_array($t))
			$typesdoclib = $t;	
	}
	
	if (isset($typesdoclib[$extension]))
		$return = $typesdoclib[$extension];
	
	return $return;
}

function cisquel_extensions_utilisees(){
	$return = array();
	$result = sql_select('extension','spip_documents','','extension');
	while ($row = sql_fetch($result))
		$return[] = $row['extension'];
	
	return $return;
}

function cisquel_extension_est_utilisee($extension=''){
	$extensions = cisquel_extensions_utilisees();
	return in_array($extension,$extensions);
}

function cisquel_extensions_media($media=''){
	$return = array();
	if ($media){
		$typesdoc = cisquel_extensions_utilisees();
	
		if (is_array($typesdoc)) {
			$in = sql_in('extension',$typesdoc);		
			$result = sql_select("mime_type,extension","spip_types_documents",$in);
			while ($row = sql_fetch($result)) {
				$type_mime = $row['mime_type'];
				// type de media
				$media_row = "file";
				if (preg_match(",^image/,",$type_mime) OR in_array($type_mime,array('application/illustrator')))
					$media_row = "image";
				elseif (preg_match(",^audio/,",$type_mime))
					$media_row = "audio";
				elseif (preg_match(",^video/,",$type_mime) OR in_array($type_mime,array('application/ogg','application/x-shockwave-flash','application/mp4')))
					$media_row = "video";
					
				if ($media_row == $media)
					$return[] = $row['extension'];
			}
		}
	}	
	
	return $return;
}

function cisquel_choix_extensions($media='',$extension=''){
	$return = array();	

	if ($extension AND cisquel_extension_est_utilisee($extension))
		$return = array($extension);
	elseif ($media AND in_array($media,array('file','image','audio','video')))
		$return = cisquel_extensions_media($media);
	else
		$return = cisquel_extensions_utilisees();
	
	return $return;
}

function cisquel_verifier_extension($extension=''){
        $return = '';
        $typesdoc = cisquel_typesdoc();
        if ($typesdoc AND is_array($typesdoc)) {
                if (in_array($extension,$typesdoc))
                        $return = 'oui';
        }
        return $return;
}

function cisquel_title_recherche($recherche='', $env=array()) {
    
    if (!cisquel_recherche_autorise($recherche)){
        $return = _T('cisquel:recherche_non_autorise');

    } else {
	include_spip('inc/charsets');
        
        $return = _T('cisquel:eq_recherche_title');
        
      	// indispensable (necessite un #ENV sans filtre)
	$unenv = unserialize($env);
	
	// securite
	$p_safe = cisquel_verifier_parametres($unenv);
        
        $libelles_onglets = array('article'=>'articles',
                                'rubrique'=>'rubriques',
                                'document'=>'cisquel:onglet_documents',
                                'forum'=>'cisquel:eq_commentaires');
        $libelles_elargir = array('doc'=>'cisquel:elargir_doc',
                                'toussites'=>'cisquel:elargir_toussites');
        $libelles_tri = array('datedesc'=>'cisquel:pardatedesc',
                                'date'=>'cisquel:pardate');
        
        $return .= " : ".charset2unicode(interdire_scripts(entites_html($p_safe['recherche'])));
        $return .= " (";
        if ($p_safe['onglet'])   
            $return .= _T($libelles_onglets[$p_safe['onglet']]);
        
        $page = 1;
        if ($p_safe['np'])
            $page = $p_safe['np'];
        elseif ($p_safe['onglet']=='article' AND $p_safe['debut_articles'])
            $page = 1 + ($p_safe['debut_articles']/10);
        elseif ($p_safe['onglet']=='rubrique' AND $p_safe['debut_rubriques'])
            $page = 1 + ($p_safe['debut_rubriques']/10);
        elseif ($p_safe['onglet']=='document' AND $p_safe['debut_doc'])
            $page = 1 + ($p_safe['debut_doc']/10);
        elseif ($p_safe['onglet']=='forum' AND $p_safe['debut_messages'])
            $page = 1 + ($p_safe['debut_messages']/10);
        
        $return .= " - "._T('cisquel:eq_page')." : ".strval($page);
        
        if ($p_safe['age'])   
            $return .= " - "._T('cisquel:depuis')." ".$p_safe['age']." "._T('date_jours');
        if ($p_safe['datedebut'])
            $return .= " - "._T('cisquel:datedebut')." : ".$p_safe['datedebut'];
        if ($p_safe['datefin'])   
            $return .= " - "._T('cisquel:datefin')." : ".$p_safe['datefin'];
        if ($p_safe['typedoc'])   
            $return .= " - "._T('cisquel:doc_format')." ".$p_safe['typedoc'];
        if ($p_safe['elargir'])   
            $return .= " - "._T($libelles_elargir[$p_safe['elargir']]);
        if ($p_safe['tri'])   
            $return .= " - "._T('cisquel:tri')." "._T($libelles_tri[$p_safe['tri']]);
        $return .= ")";
    }
    
    return unicode2charset(html2unicode($return));
}

function cisquel_recherche_verifier($arg=''){

    if (_request('type_nbt')){ // cas facile
        cisquel_redirige_404();            
    }
    
    return "";
}

?>