<?php
/**
 * Plugin CISTYLE
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */


function cistyle_declarer_tables_principales($tables_principales){
        
	// table de config
	$spip_cistyle_config = array(
            "nom"          => "varchar(255) NOT NULL",
            "valeur"       => "text DEFAULT ''");

	$spip_cistyle_config_key = array(
		"PRIMARY KEY" 	=> "nom"
        );
	
	$tables_principales['spip_cistyle_config'] = array(
		'field' => &$spip_cistyle_config,
		'key' => &$spip_cistyle_config_key);
        
        
	// table des styles
        // ATTENTION : pour la compatibilité avec l'import / export de configuration
        // id_style n'est volontairement pas la clé primaire afin de ne pas être auto incrémenté.
        // Juste après la création d'un style, la valeur de id_auto sera recopiée dans id_style
	$spip_cistyle_styles = array(
		"id_auto"	=> "bigint(21) NOT NULL",
		"id_style"	=> "VARCHAR(255) DEFAULT '' NOT NULL",
		"nom"           => "text DEFAULT '' NOT NULL",
		"valeur"	=> "text DEFAULT '' NOT NULL",
		"statut"	=> "VARCHAR(10) DEFAULT 'active' NOT NULL",
		"rang"          => "int(4) DEFAULT '0' NOT NULL",
		"maj"		=> "TIMESTAMP");

	$spip_cistyle_styles_key = array(
		"PRIMARY KEY"	=> "id_auto",
                "KEY id_style"	=> "id_style");

	$tables_principales['spip_cistyle_styles'] = array(
		'field' => &$spip_cistyle_styles,
		'key' 	=> &$spip_cistyle_styles_key);

        
	return $tables_principales;
}


function cistyle_declarer_tables_interfaces($interface){
	
	$interface['table_des_tables']['cistyle_config']='cistyle_config';
	
	return $interface;
}

?>