<?php
/**
 * Plugin citrace
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/citrace_commun');


function exec_citrace_export() {

	if (!autoriser('configurer')) {
		include_spip('inc/minipres');
		echo minipres();
	} else {
                $fichier_extension = 'csv';
                $content_type = 'text/comma-separated-values';
                $fichier_nom = "citrace_".date("Y-m-d").".".$fichier_extension;
                
               	if (defined('_CITRACE_ANONYME_POUR_ADMIN') AND _CITRACE_ANONYME_POUR_ADMIN=='oui')
                    $fichier = trim(recuperer_fond("prive/objets/liste/citrace_export_anonyme", array()));
                else
                    $fichier = trim(recuperer_fond("prive/objets/liste/citrace_export", array()));

                // changer de charset le cas echeant
                if ($cicharset=_request('charset') AND in_array($cicharset,array('iso-8859-1','utf-8'))){
                        if ($GLOBALS['meta']['charset'] != $cicharset){
                                include_spip('inc/charsets');
                                $fichier = unicode2charset(charset2unicode($fichier), $cicharset);
                        }
                        $fichier_nom = "citrace_".$cicharset."_".date("Y-m-d").".".$fichier_extension;
                }
                
                header("Content-type: ".$content_type);
                header("Content-Disposition: attachment; filename=\"$fichier_nom\";");			
                header("Expires: 0");
                header("Last-Modified: " .gmdate("D, d M Y H:i:s"). " GMT");
                header("Cache-Control: no-store, no-cache, must-revalidate");
                header("Pragma: no-cache");
                echo $fichier;
	}	
}

function citrace_filtre_csv($letexte){
        if (empty($letexte)){
            return '';
        }
	// harmoniser les retours chariots
	$letexte = preg_replace(",\r\n?,S", "\n", $letexte);
	$letexte = preg_replace(",<p[>[:space:]],iS", "\n\n\\0", $letexte);
	$letexte = preg_replace(",</p[>[:space:]],iS", "\\0\n\n", $letexte);
	// supprimer les retours a la ligne
	$letexte = str_replace("\n", " ", $letexte);
	
	// remplacer les double quotes par des simples
	$letexte = str_replace('"', "'", $letexte);
	
	return $letexte;	
}

?>