<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/presentation');
include_spip('inc/config');
include_spip('inc/ciwidget_verifier');
include_spip('inc/ciwidget_graphique');
include_spip('inc/ciwidget_inc_style');

function formulaires_ciwidget_configurer_graphique_charger_dist() {
    $widget = 'graphique';
    $valeurs = formulaires_ciwidget_configurer_charger($widget);
    
    // compatibilite ascendante
    if (!isset($valeurs['largeur_defaut']) AND isset($valeurs['largeur'])){
        $valeurs['largeur_defaut'] = $valeurs['largeur'];
    }

    return $valeurs;
}

function formulaires_ciwidget_configurer_graphique_verifier_dist() {
    $widget = 'graphique';
    return formulaires_ciwidget_configurer_verifier($widget);
}

function formulaires_ciwidget_configurer_graphique_traiter_dist() {
    $widget = 'graphique';
    return formulaires_ciwidget_configurer_traiter($widget);
}

function ciwidget_graphique_config_choix_couleurs_series($arg=''){
    include_spip('inc/ciwidget_inc_meta');
    
    $return = '';
    $prefixe = _T('ciwidget:serie');
    $disabled = '';
    
    $couleurs_series = ciwidget_graphique_config_couleurs_series();

    foreach ($couleurs_series AS $nom=>$hexa){
        $return .= '<div class="ci_wrapper_color">
                    <label for="'.$nom.'">'.$prefixe.' '.str_replace('couleur_serie','',$nom).'</label>
                    <input type="text" class="color" name="'.$nom.'" id="'.$nom.'" value="'.$hexa.'" '.$disabled.'/>
                    </div>';
    }
    
    return $return;
}

function ciwidget_graphique_config_couleurs_series(){
    $couleurs_series = array();
    
    $valeurs = ciwidget_lire_meta_widget('graphique');
    
    for ($i = 1; $i <= 12; $i++){
        $nom = "couleur_serie".$i;
        $hexa = '';
        if (isset($valeurs[$nom]) AND $valeurs[$nom]){
            $couleurs_series[$nom] = $valeurs[$nom];
        }
    }
    
    return $couleurs_series;
}


function ciwidget_graphique_config_choix_type($nom_element='',$valeur_element=''){
    return ciwidget_graphique_choix_type($nom_element,$valeur_element,false);
}

function ciwidget_graphique_config_choix_ratio($nom_element='',$valeur_element=''){
    return ciwidget_graphique_choix_ratio_maximum($nom_element,$valeur_element,false);
}

function ciwidget_graphique_config_choix_position($nom_element='',$valeur_element=''){
    return ciwidget_graphique_choix_position($nom_element,$valeur_element,false);
}

function ciwidget_graphique_config_choix_align($nom_element='',$valeur_element=''){
    return ciwidget_graphique_choix_align($nom_element,$valeur_element,false);
}

function ciwidget_graphique_config_choix_point_style($nom_element='',$valeur_element=''){
    return ciwidget_graphique_choix_point_style($nom_element,$valeur_element,false);
}

function ciwidget_graphique_config_choix_point_radius($nom_element='',$valeur_element=''){
    return ciwidget_graphique_choix_point_radius($nom_element,$valeur_element,false);
}

function ciwidget_graphique_config_choix_fontsize($nom_element='',$valeur_element=''){
    $return = '';
    $selected = '';
    $disabled = '';
    
    if (!$valeur_element){
        $valeur_element = '12';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array('8','9','10','11','12','13','14','15','16','17','18');
    // Parcours du tableau
    $return .= '<select name="'.$nom_element.'" '.$disabled.'>'."\n";
    foreach($tableau_valeurs as $valeur){
        if($valeur == $valeur_element){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. $valeur .'px</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}

function ciwidget_graphique_config_choix_lineborderwidth_defaut($nom_element='',$valeur_element=''){
    $return = '';
    $selected = '';
    $disabled = '';
    
    if (!$valeur_element){
        $valeur_element = '1';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array('1','2','3','4','5','6','7','8');
    // Parcours du tableau
    $return .= '<select name="'.$nom_element.'" '.$disabled.'>'."\n";
    foreach($tableau_valeurs as $valeur){
        if($valeur == $valeur_element){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. $valeur .'</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}

?>