<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/ciwidget_tmp');
include_spip('inc/ciwidget_graphique');

function formulaires_ciwidget_graphique1_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
	if (!$id_widget AND !$id_widget_tmp AND !autoriser('modifier',$objet,$id_objet)){
		return false;
        }
        
        // parametres : identifiants, type de widget, valeurs par defaut (mode creation du widget et premier affichage du formulaire)
        $valeurs = ciwidget_valeurs_tmp($id_widget,$id_widget_tmp,'graphique');

        // securite
        if (intval($id_widget_tmp) > 0){
            if (!isset($valeurs['objet']) OR !isset($valeurs['id_objet']) OR !isset($valeurs['id_auteur']) 
                    OR !autoriser('modifier',$valeurs['objet'],$valeurs['id_objet'])
                    OR $valeurs['id_auteur']!=$GLOBALS['visiteur_session']['id_auteur']){
                    return false;
            }
        }
        
        $valeurs['retour_objet'] = ciwidget_retour_tmp_vers_objet($id_widget_tmp,$objet,$id_objet,$valeurs);

        // valeur par defaut
        if (!isset($valeurs['type'])){
            // valeurs par defaut
            $valeurs_par_defaut = ciwidget_graphique_config_par_defaut();
            if (isset($valeurs_par_defaut['type'])){
                $valeurs['type'] = $valeurs_par_defaut['type'];
            }
        }         
        
        // stacked ?
        if (isset($valeurs['type']) AND in_array($valeurs['type'],array('bar','horizontalBar')) 
                AND isset($valeurs['yAxes_stacked']) AND $valeurs['yAxes_stacked']=='true'){
            $valeurs['type'] .= '_stacked';
        }

        // moyenne ?
        if (isset($valeurs['type']) AND in_array($valeurs['type'],array('bar','bar_stacked')) 
                AND isset($valeurs['moyenne_active']) AND $valeurs['moyenne_active']=='oui'){
            $valeurs['type'] .= '_moyenne';
        }

        $valeurs['ci_action'] = self('&', true);
        
	return $valeurs;
}

function formulaires_ciwidget_graphique1_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        $erreurs = array();
        
	$type = _request('type');	
	if (!$type){
		$erreurs['type'] = _T('info_obligatoire');
        } elseif (!in_array($type,array('line','bar','bar_stacked','bar_moyenne','bar_stacked_moyenne','horizontalBar','horizontalBar_stacked','radar','pie','doughnut')) ){
		$erreurs['type'] = _T('ciwidget:valeur_incorrecte');
        }

	return $erreurs;
}

function formulaires_ciwidget_graphique1_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        $type_widget = 'graphique';
        $c = array();
        $c['type_widget'] = $type_widget;
        if ($objet){
            $c['objet'] = $objet;
        }
        if ($id_objet){
            $c['id_objet'] = $id_objet;
        }
        if ($id_widget){
            $c['id_widget'] = $id_widget;
        }
        if (!$id_widget_tmp){
            $c['id_auteur'] = intval($GLOBALS['visiteur_session']['id_auteur']);
        }
        $contenu_nouveau = array();
        $request_type = _request('type');
        if (!empty($request_type)){
        	$contenu_nouveau['type'] = $request_type;
        } else {
        	$contenu_nouveau['type'] = '';
        }
        $contenu_nouveau['yAxes_stacked'] = 'false';
        $contenu_nouveau['moyenne_active'] = 'non';
        
        // stacked ?
        if (strpos($contenu_nouveau['type'],'_stacked')>0){
            $contenu_nouveau['type'] = str_replace('_stacked','',$contenu_nouveau['type']);
            $contenu_nouveau['yAxes_stacked'] = 'true';
        }
        
        // moyenne ?
        if (strpos($contenu_nouveau['type'],'_moyenne')>0){
            $contenu_nouveau['type'] = str_replace('_moyenne','',$contenu_nouveau['type']);
            $contenu_nouveau['moyenne_active'] = 'oui';
        }
        
        $id_widget_tmp = ciwidget_maj_tmp($id_widget,$id_widget_tmp,$c,$contenu_nouveau);

        $res = ciwidget_retour_formulaire_etape($objet,$id_objet,$id_widget,$id_widget_tmp,$type_widget,ciwidget_numform());

	return $res;
}

?>