<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/twitter_commun');

function formulaires_ciwidget_tweet_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet))
		return false;

        $valeurs = array('titre'=>'','descriptif'=>'','url'=>'','conversation'=>'','largeur'=>ciwidget_lire_meta_cle('tweet','largeur_defaut'));
        
        $id_widget = intval($id_widget);
	if ($id_widget>0) {
		$result = sql_select("*", "spip_ciwidget", "id_widget=$id_widget");
		while ($row = sql_fetch($result)) { 
			$valeurs = $row;
		}
        
                // anti hack
                if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!='tweet'){
                    return false;
                }
                
                // unserialize le champ contenu
                if (isset($valeurs['contenu'])){
                    $contenu = unserialize($valeurs['contenu']);
                    $valeurs['contenu'] = '';
                    if ($contenu AND is_array($contenu)){
                        $valeurs = array_merge($valeurs,$contenu);
                    }
                }
	}

        if (ciwidget_lire_meta_cle('tweet','largeur_non_modifiable')=='oui'){
            $valeurs['ci_largeur_non_modifiable'] = 'oui';
            $valeurs['largeur'] = ciwidget_lire_meta_cle('tweet','largeur_defaut');
        }

        $valeurs['retour_objet'] = ciwidget_retour_vers_objet($objet, $id_objet);

	return $valeurs;
}

function formulaires_ciwidget_tweet_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $erreurs = array();
        
	$titre = _request('titre');	
	if (!$titre){
		$erreurs['titre'] = _T('info_obligatoire');
        }
        
	$url = _request('url');	
	if (!$url){
		$erreurs['url'] = _T('info_obligatoire');
        } elseif (!ci_tweet_url($url)) {
		$erreurs['url'] = _T('ciwidget:valeur_incorrecte');
        }
        
	if (ciwidget_erreur_largeur(_request('largeur'))){
            $erreurs['largeur'] = ciwidget_erreur_largeur(_request('largeur'));
        }
        
        $conversation = _request('conversation');
        if (!in_array($conversation, array('oui','non'))){
		$erreurs['conversation'] = _T('ciwidget:valeur_incorrecte');
        }
        
	return $erreurs;
}

function formulaires_ciwidget_tweet_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $id_widget = intval($id_widget);

        $c = array();
	foreach (array('titre', 'descriptif') as $champ){
		$c[$champ] = _request($champ);
        }
        
        $url = _request('url');
        $conversation = _request('conversation');
        if (!in_array($conversation, array('oui','non'))){
            $conversation = '';
        }
        $largeur = ciwidget_verif_largeur_sinon_defaut(_request('largeur'), ciwidget_lire_meta_cle('tweet','largeur_defaut'));
        
        $type_widget = 'tweet';
        $c['contenu'] = serialize(array('url'=>$url, 'conversation'=>$conversation, 'largeur'=>$largeur));
        $c['type_widget'] = $type_widget;
        $c['objet'] = $objet;
        $c['id_objet'] = $id_objet;

	if ($id_widget>0) {
            // modifier
            sql_updateq("spip_ciwidget", $c, "id_widget=$id_widget");
        } else {
            // ajouter et lier
            $id_widget = sql_insertq('spip_ciwidget', $c);
        }
    
        $res = ciwidget_retour_formulaire($objet,$id_objet,$type_widget,$retour);

	return $res;
}

?>